using Foundation;
using System;
using System.CodeDom.Compiler;
using UIKit;
using Syncfusion.SfDataGrid;
using CoreGraphics;

namespace Sample
{
	partial class SecondTabViewController : UIViewController
	{

		SfDataGrid sfGrid;
		GridTextColumn vColunaGrid_Conta;
		GridTextColumn vColunaGrid_Saldo;

		public SecondTabViewController (IntPtr handle) : base (handle)
		{
			sfGrid = new SfDataGrid(); //Instancia o componente DataGrid            

			//Adiciona manualmente as colunas
			#region Adiciona colunas do DataGrid
			UILabel vCapturaInfFonte = new UILabel();

			sfGrid.AutoGenerateColumns = false;
			vColunaGrid_Conta = new GridTextColumn();
			vColunaGrid_Conta.HeaderFont = UIFont.FromName(vCapturaInfFonte.Font.Name, 12f);
			vColunaGrid_Conta.RecordFont = UIFont.FromName(vCapturaInfFonte.Font.Name, 12f);
			vColunaGrid_Conta.MappingName = "DetalhesSaldoBancario_Conta";
			vColunaGrid_Conta.HeaderText = "     Conta";
			vColunaGrid_Conta.HeaderTextAlignment = UITextAlignment.Left;
			vColunaGrid_Conta.TextMargin = 16;
			vColunaGrid_Conta.TextAlignment = UITextAlignment.Left;            
			//vColunaGrid_Conta.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.75;                            
			sfGrid.Columns.Add(vColunaGrid_Conta);


			vColunaGrid_Saldo = new GridTextColumn();
			vColunaGrid_Saldo.HeaderFont = UIFont.FromName(vCapturaInfFonte.Font.Name, 12f);
			vColunaGrid_Saldo.RecordFont = UIFont.FromName(vCapturaInfFonte.Font.Name, 12f);
			vColunaGrid_Saldo.MappingName = "DetalhesSaldoBancario_Saldo";
			vColunaGrid_Saldo.HeaderText = "Saldo    .";
			vColunaGrid_Saldo.HeaderTextAlignment = UITextAlignment.Right;            
			vColunaGrid_Saldo.TextMargin = 16;
			vColunaGrid_Saldo.TextAlignment = UITextAlignment.Right;
			//vColunaGrid_Saldo.Width = DataGridSaldoBancarioUIView.Frame.Width * 0.25;            
			sfGrid.Columns.Add(vColunaGrid_Saldo);

			#endregion

			#region Ordenação de colunas
			//Permite ordernar colunas automaticamente
			//sfGrid.AllowSorting = true;

			//Permite ordenar colunas manualmente
			//sfGrid.SortColumnDescriptions.Add(new SortColumnDescription() { ColumnName = "DetalhesSaldoBancario_Conta" });
			#endregion

			//Agrupamento das colunas
			//sfGrid.GroupColumnDescriptions.Add(new GroupColumnDescription() { ColumnName = "DetalhesSaldoBancario_Conta" }); 


			//Fonte de dados do DataGrid
			sfGrid.ItemsSource = (new DetalheSaldoBancarioRepositorio().OrderDetails);


			sfGrid.HeaderRowHeight = 26;
			sfGrid.RowHeight = 25;

			//Evento para manipular o tamanho (altura) da row
			sfGrid.QueryRowHeight += QueryRowHeight;

			//Evento para manipular o evento de criação da grid
			sfGrid.GridViewCreated += GridViewCreated;

			sfGrid.BackgroundColor = UIColor.Blue;
		}

		//Evento para manipular o tamanho (altura) da row
		void QueryRowHeight(object sender, QueryRowHeightEventArgs e)
		{
			if (e.RowIndex > 0)
			{
				//Pega o tamanho "correto" da row
				double height = SfDataGridHelpers.GetRowHeight(sfGrid, e.RowIndex);
				//Se for maior que 60, é porque provavelmente deu mais de uma linha. Neste caso, ajusta o tamanho (altura) da row
				if (height > 56)
				{
					e.Height = height - 30;
					e.Handled = true;
				}
			}
		}


		void GridViewCreated(object sender, GridViewCreatedEvent e)
		{
			//Seta o estilo das células
			#region Estilo das células e do header do DataGrid
			if (sfGrid != null)
			{
				DataGridStyle vEstiloDoDataGrid = new DataGridStyle();
				vEstiloDoDataGrid.HeaderBackground = UIColor.Black;
				vEstiloDoDataGrid.HeaderForeground = UIColor.White;
				vEstiloDoDataGrid.CellForeground = UIColor.White;
				vEstiloDoDataGrid.CellBackground = UIColor.DarkGray;
				sfGrid.GridStyle = vEstiloDoDataGrid;
			}
			#endregion
		}

		private bool skip = true; 
		public override void ViewDidLayoutSubviews()
		{
			base.ViewDidLayoutSubviews();

			if (sfGrid != null && !skip)
			{
				this.sfGrid.Frame = new CGRect(5, 5, InnerView.Frame.Width-20, this.InnerView.Frame.Height-20);

				//Ajusta tamanho da largura das colunas
				vColunaGrid_Conta.Width = sfGrid.Frame.Width * 0.60;
				vColunaGrid_Saldo.Width = sfGrid.Frame.Width * 0.40;

				//Tamanho do DataGrid
			}
			skip = false;
		}

		public override void DidRotate (UIInterfaceOrientation fromInterfaceOrientation)
		{
			base.DidRotate (fromInterfaceOrientation);
		}
			
		public override void ViewDidLoad()
		{
			base.ViewDidLoad();            
			//Adiciona o Grid na tela            
			InnerView.AddSubview(sfGrid);
			//this.sfGrid.Frame = new CGRect(5, 5, InnerView.Frame.Width-20, 440-20);
			//this.sfGrid.Frame = new CGRect(5, 5, InnerView.Frame.Width-20, InnerView.Frame.Height-20);
			//InnerView.AutoresizingMask = UIViewAutoresizing.All;
			//this.sfGrid.Frame = new CGRect(5, 5, InnerView.Frame.Width-20, InnerView.Frame.Height-20);
			//TotalSaldoBancarioUILabel.Text = PlataformaSage.Financas.Classes.Funcoes.FormataString("14456.80", Classes.Funcoes.TiposFormatacao.Moeda);
		}




		public override void ViewDidDisappear(bool animated)
		{
			base.ViewDidDisappear(animated);
			//Limpa o componente gráfico da memória
			//this.sfGrid.Dispose();
			//this.sfGrid = null;
		}
	}
}

